Index: dports/lang/python25/files/patch-Include-pymactoolbox.h.diff
===================================================================
--- dports/lang/python25/files/patch-Include-pymactoolbox.h.diff	(revision 0)
+++ dports/lang/python25/files/patch-Include-pymactoolbox.h.diff	(revision 0)
@@ -0,0 +1,121 @@
+--- Include/pymactoolbox.h.orig	2004-11-04 23:02:59.000000000 -0800
++++ Include/pymactoolbox.h	2009-09-02 00:30:17.000000000 -0700
+@@ -8,7 +8,12 @@
+ #endif
+ 
+ #include <Carbon/Carbon.h>
++
++#ifndef __LP64__
++#ifndef __LP64__
+ #include <QuickTime/QuickTime.h>
++#endif /* !__LP64__ */
++#endif /* !__LP64__ */
+ 
+ /*
+ ** Helper routines for error codes and such.
+@@ -18,8 +23,11 @@
+ PyObject *PyMac_GetOSErrException(void);	/* Initialize & return it */
+ PyObject *PyErr_Mac(PyObject *, int);		/* Exception with a mac error */
+ PyObject *PyMac_Error(OSErr);			/* Uses PyMac_GetOSErrException */
++#ifndef __LP64__ 
+ extern OSErr PyMac_GetFullPathname(FSSpec *, char *, int); /* convert
+ 							      fsspec->path */
++#endif /* __LP64__ */
++
+ /*
+ ** These conversion routines are defined in mactoolboxglue.c itself.
+ */
+@@ -83,8 +91,10 @@
+ #endif /* USE_TOOLBOX_OBJECT_GLUE */
+ 
+ /* macfs exports */
++#ifndef __LP64__
+ int PyMac_GetFSSpec(PyObject *, FSSpec *);	/* argument parser for FSSpec */
+ PyObject *PyMac_BuildFSSpec(FSSpec *);		/* Convert FSSpec to PyObject */
++#endif /* !__LP64__ */
+ 
+ int PyMac_GetFSRef(PyObject *, FSRef *);	/* argument parser for FSRef */
+ PyObject *PyMac_BuildFSRef(FSRef *);		/* Convert FSRef to PyObject */
+@@ -101,39 +111,55 @@
+ extern int CmpInstObj_Convert(PyObject *, ComponentInstance *);
+ 
+ /* Ctl exports */
++#ifndef __LP64__
+ extern PyObject *CtlObj_New(ControlHandle);
+ extern int CtlObj_Convert(PyObject *, ControlHandle *);
++#endif /* !__LP64__ */
+ 
+ /* Dlg exports */
++#ifndef __LP64__
+ extern PyObject *DlgObj_New(DialogPtr);
+ extern int DlgObj_Convert(PyObject *, DialogPtr *);
+ extern PyObject *DlgObj_WhichDialog(DialogPtr);
++#endif /* !__LP64__ */
+ 
+ /* Drag exports */
++#ifndef __LP64__
+ extern PyObject *DragObj_New(DragReference);
+ extern int DragObj_Convert(PyObject *, DragReference *);
++#endif /* !__LP64__ */
+ 
+ /* List exports */
++#ifndef __LP64__
+ extern PyObject *ListObj_New(ListHandle);
+ extern int ListObj_Convert(PyObject *, ListHandle *);
++#endif /* !__LP64__ */
+ 
+ /* Menu exports */
++#ifndef __LP64__
+ extern PyObject *MenuObj_New(MenuHandle);
+ extern int MenuObj_Convert(PyObject *, MenuHandle *);
++#endif /* !__LP64__ */
+ 
+ /* Qd exports */
++#ifndef __LP64__
+ extern PyObject *GrafObj_New(GrafPtr);
+ extern int GrafObj_Convert(PyObject *, GrafPtr *);
+ extern PyObject *BMObj_New(BitMapPtr);
+ extern int BMObj_Convert(PyObject *, BitMapPtr *);
+ extern PyObject *QdRGB_New(RGBColor *);
+ extern int QdRGB_Convert(PyObject *, RGBColor *);
++#endif /* !__LP64__ */
+ 
+ /* Qdoffs exports */
++#ifndef __LP64__
+ extern PyObject *GWorldObj_New(GWorldPtr);
+ extern int GWorldObj_Convert(PyObject *, GWorldPtr *);
++#endif /* !__LP64__ */
+ 
++#ifndef __LP64__
+ /* Qt exports */
++#ifndef __LP64__
+ extern PyObject *TrackObj_New(Track);
+ extern int TrackObj_Convert(PyObject *, Track *);
+ extern PyObject *MovieObj_New(Movie);
+@@ -146,6 +172,8 @@
+ extern int UserDataObj_Convert(PyObject *, UserData *);
+ extern PyObject *MediaObj_New(Media);
+ extern int MediaObj_Convert(PyObject *, Media *);
++#endif /* !__LP64__ */
++#endif /* !__LP64__ */
+ 
+ /* Res exports */
+ extern PyObject *ResObj_New(Handle);
+@@ -154,13 +182,17 @@
+ extern int OptResObj_Convert(PyObject *, Handle *);
+ 
+ /* TE exports */
++#ifndef __LP64__
+ extern PyObject *TEObj_New(TEHandle);
+ extern int TEObj_Convert(PyObject *, TEHandle *);
++#endif /* !__LP64__ */
+ 
+ /* Win exports */
++#ifndef __LP64__
+ extern PyObject *WinObj_New(WindowPtr);
+ extern int WinObj_Convert(PyObject *, WindowPtr *);
+ extern PyObject *WinObj_WhichWindow(WindowPtr);
++#endif /* !__LP64__ */
+ 
+ /* CF exports */
+ extern PyObject *CFObj_New(CFTypeRef);
Index: dports/lang/python25/Portfile
===================================================================
--- dports/lang/python25/Portfile	(revision 56887)
+++ dports/lang/python25/Portfile	(working copy)
@@ -5,7 +5,7 @@
 
 name                    python25
 version                 2.5.4
-revision                6
+revision                6.1
 set branch              [join [lrange [split ${version} .] 0 1] .]
 categories              lang
 platforms               darwin
@@ -162,7 +162,8 @@
         configure.cppflags-append   -D_DARWIN_C_SOURCE
         patchfiles-append           patch-configure-badcflags.diff \
                                     patch-configure-arch_only.diff \
-                                    patch-pyconfig.h.in.diff
+                                    patch-pyconfig.h.in.diff \
+                                    patch-Include-pymactoolbox.h.diff
 }
 
 platform puredarwin {