diff -urN /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/py_curses.h /opt/local/include/python2.5/py_curses.h
--- /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/py_curses.h	2009-07-07 23:55:38.000000000 -0700
+++ /opt/local/include/python2.5/py_curses.h	2009-08-31 10:01:37.000000000 -0700
@@ -40,7 +40,6 @@
 #endif
 
 #ifdef HAVE_NCURSES_H
-#define NCURSES_OPAQUE 0
 #include <ncurses.h>
 #else
 #include <curses.h>
diff -urN /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/pyconfig.h /opt/local/include/python2.5/pyconfig.h
--- /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/pyconfig.h	2009-07-07 23:55:38.000000000 -0700
+++ /opt/local/include/python2.5/pyconfig.h	2009-08-31 10:01:37.000000000 -0700
@@ -5,6 +5,10 @@
 #ifndef Py_PYCONFIG_H
 #define Py_PYCONFIG_H
 
+// Required on Darwin 10+
+#ifndef _DARWIN_C_SOURCE
+#define _DARWIN_C_SOURCE
+#endif
 
 /* Define for AIX if your compiler is a genuine IBM xlC/xlC_r and you want
    support for AIX C++ shared extension modules. */
@@ -287,11 +291,7 @@
    and long long is available and at least as big as an off_t. You may need to
    add some flags for configuration and compilation to enable this mode. (For
    Solaris and Linux, the necessary defines are already defined.) */
-#ifdef __LP64__
 /* #undef HAVE_LARGEFILE_SUPPORT */
-#else
-#define HAVE_LARGEFILE_SUPPORT 1
-#endif
 
 /* Define to 1 if you have the `lchown' function. */
 #define HAVE_LCHOWN 1
@@ -306,7 +306,7 @@
 /* #undef HAVE_LIBIEEE */
 
 /* Define to 1 if you have the <libintl.h> header file. */
-/* #undef HAVE_LIBINTL_H */
+#define HAVE_LIBINTL_H 1
 
 /* Define to 1 if you have the `readline' library (-lreadline). */
 #define HAVE_LIBREADLINE 1
@@ -315,7 +315,7 @@
 /* #undef HAVE_LIBRESOLV */
 
 /* Define to 1 if you have the <libutil.h> header file. */
-#define HAVE_LIBUTIL_H 1
+/* #undef HAVE_LIBUTIL_H */
 
 /* Define if you have the 'link' function. */
 #define HAVE_LINK 1
@@ -378,10 +378,10 @@
 /* #undef HAVE_PLOCK */
 
 /* Define to 1 if you have the `poll' function. */
-/* #undef HAVE_POLL */
+#define HAVE_POLL 1
 
 /* Define to 1 if you have the <poll.h> header file. */
-/* #undef HAVE_POLL_H */
+#define HAVE_POLL_H 1
 
 /* Define to 1 if you have the <process.h> header file. */
 /* #undef HAVE_PROCESS_H */
@@ -420,7 +420,7 @@
 #define HAVE_RL_CALLBACK 1
 
 /* Define if you can turn off readline's signal handling. */
-/* #undef HAVE_RL_CATCH_SIGNAL */
+#define HAVE_RL_CATCH_SIGNAL 1
 
 /* Define if you have readline 2.2 */
 #define HAVE_RL_COMPLETION_APPEND_CHARACTER 1
@@ -779,7 +779,7 @@
 /* #undef Py_DEBUG */
 
 /* Defined if Python is built as a shared library. */
-/* #undef Py_ENABLE_SHARED */
+#define Py_ENABLE_SHARED 1
 
 /* Define as the size of the unicode type. */
 #define Py_UNICODE_SIZE 2
@@ -812,11 +812,7 @@
 #define SIZEOF_INT 4
 
 /* The size of `long', as computed by sizeof. */
-#ifdef __LP64__
 #define SIZEOF_LONG 8
-#else
-#define SIZEOF_LONG 4
-#endif
 
 /* The size of `long long', as computed by sizeof. */
 #define SIZEOF_LONG_LONG 8
@@ -825,42 +821,22 @@
 #define SIZEOF_OFF_T 8
 
 /* The number of bytes in a pthread_t. */
-#ifdef __LP64__
 #define SIZEOF_PTHREAD_T 8
-#else
-#define SIZEOF_PTHREAD_T 4
-#endif
 
 /* The size of `short', as computed by sizeof. */
 #define SIZEOF_SHORT 2
 
 /* The size of `size_t', as computed by sizeof. */
-#ifdef __LP64__
 #define SIZEOF_SIZE_T 8
-#else
-#define SIZEOF_SIZE_T 4
-#endif
 
 /* The number of bytes in a time_t. */
-#ifdef __LP64__
 #define SIZEOF_TIME_T 8
-#else
-#define SIZEOF_TIME_T 4
-#endif
 
 /* The size of `uintptr_t', as computed by sizeof. */
-#ifdef __LP64__
 #define SIZEOF_UINTPTR_T 8
-#else
-#define SIZEOF_UINTPTR_T 4
-#endif
 
 /* The size of `void *', as computed by sizeof. */
-#ifdef __LP64__
 #define SIZEOF_VOID_P 8
-#else
-#define SIZEOF_VOID_P 4
-#endif
 
 /* The size of `wchar_t', as computed by sizeof. */
 #define SIZEOF_WCHAR_T 4
@@ -879,10 +855,10 @@
 /* #undef TM_IN_SYS_TIME */
 
 /* Define if you want to use MacPython modules on MacOSX in unix-Python. */
-#define USE_TOOLBOX_OBJECT_GLUE 1
+/* #undef USE_TOOLBOX_OBJECT_GLUE */
 
 /* Define if a va_list is an array of some kind */
-/* #undef VA_LIST_IS_ARRAY */
+#define VA_LIST_IS_ARRAY 1
 
 /* Define if you want SIGFPE handled (see Include/pyfpe.h). */
 /* #undef WANT_SIGFPE_HANDLER */
@@ -903,11 +879,11 @@
 #define WITH_DYLD 1
 
 /* Define to 1 if libintl is needed for locale functions. */
-/* #undef WITH_LIBINTL */
+#define WITH_LIBINTL 1
 
 /* Define if you want to produce an OpenStep/Rhapsody framework (shared
    library plus accessory files). */
-#define WITH_NEXT_FRAMEWORK 1
+/* #undef WITH_NEXT_FRAMEWORK */
 
 /* Define if you want to compile in Python-specific mallocs */
 #define WITH_PYMALLOC 1
@@ -928,9 +904,7 @@
     such that the configure-result is used on systems that don't use GCC.
   */
 #ifdef __BIG_ENDIAN__
-#if __BIG_ENDIAN__
 #define WORDS_BIGENDIAN 1
-#endif /* __BIG_ENDIAN__ */
 #else
 #ifndef __LITTLE_ENDIAN__
 /* #undef WORDS_BIGENDIAN */
@@ -991,9 +965,6 @@
 /* Defined on Solaris to see additional function prototypes. */
 /* #undef __EXTENSIONS__ */
 
-/* Define on Mac OS X to activate all library features */
-#define _DARWIN_C_SOURCE 1
-
 /* Define to 'long' if <time.h> doesn't define. */
 /* #undef clock_t */
 
diff -urN /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/pymactoolbox.h /opt/local/include/python2.5/pymactoolbox.h
--- /System/Library/Frameworks/Python.framework/Versions/2.5/Headers/pymactoolbox.h	2009-07-07 23:55:38.000000000 -0700
+++ /opt/local/include/python2.5/pymactoolbox.h	2009-08-31 11:15:00.000000000 -0700
@@ -8,9 +8,7 @@
 #endif
 
 #include <Carbon/Carbon.h>
-#ifndef __LP64__
 #include <QuickTime/QuickTime.h>
-#endif /* !__LP64__ */
 
 /*
 ** Helper routines for error codes and such.
@@ -135,7 +133,6 @@
 extern PyObject *GWorldObj_New(GWorldPtr);
 extern int GWorldObj_Convert(PyObject *, GWorldPtr *);
 
-#ifndef __LP64__
 /* Qt exports */
 extern PyObject *TrackObj_New(Track);
 extern int TrackObj_Convert(PyObject *, Track *);
@@ -149,7 +146,6 @@
 extern int UserDataObj_Convert(PyObject *, UserData *);
 extern PyObject *MediaObj_New(Media);
 extern int MediaObj_Convert(PyObject *, Media *);
-#endif /* !__LP64__ */
 
 /* Res exports */
 extern PyObject *ResObj_New(Handle);