Index: files/patch-configure.diff
===================================================================
--- files/patch-configure.diff	(revision 71073)
+++ files/patch-configure.diff	(working copy)
@@ -1,22 +0,0 @@
---- configure.orig	2009-07-21 06:59:52.000000000 +1000
-+++ configure	2009-10-22 06:14:52.000000000 +1100
-@@ -19806,12 +19806,14 @@
- $as_echo "$ac_cv_header_Carbon_Carbon_h" >&6; }
- 
- fi
--if test "x$ac_cv_header_Carbon_Carbon_h" = x""yes; then
--  have_atsui=true
--else
--  have_atsui=false
--fi
- 
-+if test "x$have_atsui" = "x"; then
-+  if test "x$ac_cv_header_Carbon_Carbon_h" = x""yes; then
-+    have_atsui=true
-+  else
-+    have_atsui=false
-+  fi
-+fi
- 
- 
- #
Index: files/patch-which.diff
===================================================================
--- files/patch-which.diff	(revision 71073)
+++ files/patch-which.diff	(working copy)
@@ -1,20 +0,0 @@
---- docs/Makefile.in.orig	2009-05-04 15:05:17.000000000 -0500
-+++ docs/Makefile.in	2009-05-07 04:08:23.000000000 -0500
-@@ -785,7 +785,7 @@
- 	    mv -f $${installdir}/$(DOC_MODULE).devhelp \
- 	      $${installdir}/$(DOC_MODULE)-$(DOC_MODULE_VERSION).devhelp; \
- 	  fi; \
--	  ! which gtkdoc-rebase >/dev/null 2>&1 || \
-+	  ! test -x "`which gtkdoc-rebase`" || \
- 	    gtkdoc-rebase --relative --dest-dir=$(DESTDIR) --html-dir=$${installdir} ; \
- 	fi
- 
-@@ -815,7 +815,7 @@
- 	-cp $(srcdir)/$(DOC_MODULE).types $(distdir)/
- 	-cp $(srcdir)/$(DOC_MODULE)-sections.txt $(distdir)/
- 	cd $(distdir) && rm -f $(DISTCLEANFILES)
--	! which gtkdoc-rebase >/dev/null 2>&1 || \
-+	! test -x "`which gtkdoc-rebase`" || \
- 	  gtkdoc-rebase --online --relative --html-dir=$(distdir)/html
- 
- .PHONY : dist-hook-local docs
Index: Portfile
===================================================================
--- Portfile	(revision 71073)
+++ Portfile	(working copy)
@@ -6,15 +6,17 @@
 
 name                    pango
 conflicts               pango-devel
-epoch                   1
-version                 1.24.5
+set my_name             pango
+version                 1.28.1
 set branch              [join [lrange [split ${version} .] 0 1] .]
 categories              x11
 maintainers             ryandesign
 license                 LGPLv2
 homepage                http://www.pango.org/
-master_sites            gnome:sources/pango/${branch}
+master_sites            gnome:sources/${my_name}/${branch}
 platforms               darwin
+distname                ${my_name}-${version}
+dist_subdir             ${my_name}
 use_bzip2               yes
 use_parallel_build      yes
 
@@ -26,10 +28,9 @@
     open-source framework for the layout and rendering \
     of internationalized text.
 
-checksums \
-    md5     815416a452e9cccc172fed9862401f37 \
-    sha1    a5aa40b78546a7ee59f21804b172e5d47ef776ad \
-    rmd160  7e436752734c55950ad5feced7c7d5c3f040a1b4
+checksums           md5     bab5b4eb3fde6b0a5bfe98d25e668741 \
+                    sha1    2d5907f0ff108cb9c27f69d8e4de564ff3d30221 \
+                    rmd160  04531a54148a22dfcf7f3060501a0126f701ee18
 
 depends_build \
     port:pkgconfig
@@ -44,9 +45,7 @@
                         lib/libcairo.dylib
 
 patchfiles \
-    patch-which.diff \
-    patch-ltmain.sh.diff \
-    patch-configure.diff
+    patch-ltmain.sh.diff
 
 configure.ccache        no
 
@@ -57,6 +56,17 @@
     # itself differently depending on whether or not cairo is installed with
     # the quartz variant. Therefore this variant is necessary to be able to
     # distinguish whether an installed pango has quartz support or not.
+    
+    # pango 1.25.1 and up uses Core Text which is only available on 10.5+.
+    pre-extract {
+        if {${os.major} < 9} {
+            ui_error "${name} ${version} +quartz requires Mac OS X 10.5 or greater."
+            ui_error "Either don't use the +quartz variant or upgrade your Mac OS X."
+            ui_error "Concerns about this should be addressed to the Pango mailing list:"
+            ui_error "http://mail.gnome.org/mailman/listinfo/gtk-i18n-list"
+            return -code error "incompatible Mac OS X version"
+        }
+    }
 }
 }
 
@@ -102,8 +112,8 @@
     }
 }
 
-lappend merger_configure_args(ppc64)   have_atsui=false
-lappend merger_configure_args(x86_64)  have_atsui=false
+lappend merger_configure_env(ppc64)   ac_cv_header_Carbon_Carbon_h=no
+lappend merger_configure_env(x86_64)  ac_cv_header_Carbon_Carbon_h=no
 
 configure.cppflags-append \
     -no-cpp-precomp
@@ -114,12 +124,9 @@
 
 configure.args \
     --enable-static \
+    --disable-introspection \
     --x-include=${prefix}/include --x-lib=${prefix}/lib
 
-if {![variant_isset universal] && $build_arch == "x86_64" || $build_arch == "ppc64"} {
-    configure.args-append have_atsui=false
-}
-
 variant no_x11 {
     depends_lib-delete \
         port:Xft2
@@ -128,6 +135,12 @@
         --without-x
 }
 
+variant introspection description {Enable experimental GObject introspection} {
+    depends_lib-append port:gobject-introspection
+    configure.args-delete --disable-introspection
+    configure.args-append --enable-introspection=yes
+}
+
 post-destroot {
     if {[variant_isset no_x11]} {
         xinstall -d ${destroot}${prefix}/etc/pango
@@ -152,5 +165,5 @@
 test.target             check
 
 livecheck.type          regex
-livecheck.url           http://ftp.gnome.org/pub/GNOME/sources/${name}/${branch}/?C=M&O=D
-livecheck.regex         ${name}-(\[0-9.\]+)\\.tar
+livecheck.url           http://ftp.gnome.org/pub/GNOME/sources/${my_name}/${branch}/?C=M&O=D
+livecheck.regex         ${my_name}-(\[0-9.\]+)\\.tar