Index: Portfile
===================================================================
--- Portfile	(revision 64680)
+++ Portfile	(working copy)
@@ -3,45 +3,50 @@
 PortSystem 1.0
 
 name                qscintilla
-version             2.4
+version             2.4.2
 categories          devel
-maintainers         nomaintainer
+maintainers         adfernandes openmaintainer
 description         QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor control.
 homepage            http://www.riverbankcomputing.com/software/qscintilla/
 platforms           darwin
 
-long_description QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor control. \
-	As well as features found in standard text editing components,		\
-	QScintilla includes features especially useful when editing and		\
-	debugging source code. These include support for syntax styling,	\
-	error indicators, code completion and call tips. The selection		\
-	margin can contain markers like those used in debuggers to indicate	\
-	breakpoints and the current line. Styling choices are more open		\
-	than with many editors, allowing the use of proportional fonts,		\
-	bold and italics, multiple foreground and background colours and	\
-	multiple fonts. 
+long_description    QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor control. \
+                	As well as features found in standard text editing components,		\
+                	QScintilla includes features especially useful when editing and		\
+                	debugging source code. These include support for syntax styling,	\
+                	error indicators, code completion and call tips. The selection		\
+                	margin can contain markers like those used in debuggers to indicate	\
+                	breakpoints and the current line. Styling choices are more open		\
+                	than with many editors, allowing the use of proportional fonts,		\
+                	bold and italics, multiple foreground and background colours and	\
+                	multiple fonts. See the py*-qscintilla port to install python bindings.
 
+#
+# NOTE: the version of this port must be kept in sync with the 'py*-qscintilla' port(s),
+#       since they contain the python bindings!
+#
+
 distname            QScintilla-gpl-${version}
 master_sites        http://www.riverbankcomputing.com/static/Downloads/QScintilla2/
 
-checksums           md5     dd69520ec91f1acb97a4eb74ddde37c9 \
-                    sha1    17962bb64d2641f9e181b39fdca39228170488a3 \
-                    rmd160  19e5d5c331705c217c5192b1fcac5d298942db69
+checksums           sha1    17852eedaf3dfc8e8af32249d72130ddd3564019
 
-depends_lib         path:bin/qmake-mac:qt4-mac \
-                    path:bin/python:python25
+depends_lib         port:qt4-mac
 
 universal_variant   no
 
 set qt_dir          ${prefix}/libexec/qt4-mac
 
-configure.dir       ${worksrcpath}/Qt4
-configure.pre_args  INSTALLDIR=${prefix}/lib
-configure.cmd       ${qt_dir}/bin/qmake qscintilla.pro
+configure.env       QTDIR=${qt_dir}
+configure.cmd       "cd ${worksrcpath}/Qt4; ${qt_dir}/bin/qmake qscintilla.pro; \
+                     cd ${worksrcpath}/designer-Qt4; ${qt_dir}/bin/qmake designer.pro; \
+                     echo"
 
-build.dir           ${worksrcpath}/Qt4
+build.env           QTDIR=${qt_dir} CPLUS_INCLUDE_PATH=${worksrcpath}/Qt4 LIBRARY_PATH=${worksrcpath}/Qt4
+build.cmd           "cd ${worksrcpath}/Qt4; make; cd ${worksrcpath}/designer-Qt4; make; echo"
 
-build.env           QTDIR=${qt_dir} PREFIX=${prefix}
+destroot.env        QTDIR=${qt_dir} INSTALL_ROOT=${destroot}
+destroot.cmd        "cd ${worksrcpath}/Qt4; make install; cd ${worksrcpath}/designer-Qt4; make install; echo"
 
 post-build {
 	system "install_name_tool -id	\
@@ -49,17 +54,6 @@
 		${worksrcpath}/Qt4/libqscintilla2.5.dylib"
 }
 
-post-activate {
-	system "cd ${worksrcpath}/Python;python configure.py;make;make install"
-}
-
-destroot.env        QTDIR=${qt_dir} INSTALL_ROOT=${destroot}
-
-## post-configure {
-##         system "cd ${worksrcpath}/clib/qtc && qmake qtc.pro INSTALLDIR=${prefix}/lib -o Makefile"
-##         reinplace "s;-lqt;-lqt-mt;" ${worksrcpath}/clib/qtc/Makefile
-## }
-
-
-#
-##EOF
+livecheck.type      regex
+livecheck.url       ${master_sites}
+livecheck.regex     QScintilla-gpl-\(\\d+.\\d+.\\d+\).tar.gz